diff --git a/target-m68k/cpu.h b/target-m68k/cpu.h
index 0e4ff08..d3acd33 100644
--- a/target-m68k/cpu.h
+++ b/target-m68k/cpu.h
@@ -129,7 +129,6 @@ int cpu_m68k_exec(CPUState *cpu);
    is returned if the signal was handled by the virtual CPU.  */
 int cpu_m68k_signal_handler(int host_signum, void *pinfo,
                            void *puc);
-void cpu_m68k_flush_flags(CPUM68KState *, int);
 
 enum {
     CC_OP_DYNAMIC, /* Use env->cc_op  */
diff --git a/target-m68k/helper.c b/target-m68k/helper.c
index ec37c9d..c3e4380 100644
--- a/target-m68k/helper.c
+++ b/target-m68k/helper.c
@@ -131,9 +131,8 @@ void m68k_cpu_init_gdb(M68kCPU *cpu)
     /* TODO: Add [E]MAC registers.  */
 }
 
-void cpu_m68k_flush_flags(CPUM68KState *env, int cc_op)
+static uint32_t cpu_m68k_flush_flags(CPUM68KState *env, int op)
 {
-    M68kCPU *cpu = m68k_env_get_cpu(env);
     int flags;
     uint32_t src;
     uint32_t dest;
@@ -201,7 +200,7 @@ void cpu_m68k_flush_flags(CPUM68KState *env, int cc_op)
     flags = 0;
     src = env->cc_src;
     dest = env->cc_dest;
-    switch (cc_op) {
+    switch (op) {
     case CC_OP_FLAGS:
         flags = dest;
         break;
@@ -267,10 +266,9 @@ set_x:
         SET_FLAGS_SHIFT(int32_t);
         break;
     default:
-        cpu_abort(CPU(cpu), "Bad CC_OP %d", cc_op);
+        g_assert_not_reached();
     }
-    env->cc_op = CC_OP_FLAGS;
-    env->cc_dest = flags;
+    return flags;
 }
 
 void HELPER(movec)(CPUM68KState *env, uint32_t reg, uint32_t val)
@@ -421,20 +419,21 @@ uint32_t HELPER(subx_cc)(CPUM68KState *env, uint32_t op1, uint32_t op2)
 {
     uint32_t res;
     uint32_t old_flags;
+    int op;
 
     old_flags = env->cc_dest;
     if (env->cc_x) {
         env->cc_x = (op1 <= op2);
-        env->cc_op = CC_OP_SUBX;
+        op = CC_OP_SUBX;
         res = op1 - (op2 + 1);
     } else {
         env->cc_x = (op1 < op2);
-        env->cc_op = CC_OP_SUB;
+        op = CC_OP_SUB;
         res = op1 - op2;
     }
     env->cc_dest = res;
     env->cc_src = op2;
-    cpu_m68k_flush_flags(env, env->cc_op);
+    env->cc_dest = cpu_m68k_flush_flags(env, op);
     /* !Z is sticky.  */
     env->cc_dest &= (old_flags | ~CCF_Z);
     return res;
@@ -444,20 +443,21 @@ uint32_t HELPER(addx_cc)(CPUM68KState *env, uint32_t op1, uint32_t op2)
 {
     uint32_t res;
     uint32_t old_flags;
+    int op;
 
     old_flags = env->cc_dest;
     if (env->cc_x) {
         res = op1 + op2 + 1;
         env->cc_x = (res <= op2);
-        env->cc_op = CC_OP_ADDX;
+        op = CC_OP_ADDX;
     } else {
         res = op1 + op2;
         env->cc_x = (res < op2);
-        env->cc_op = CC_OP_ADD;
+        op = CC_OP_ADD;
     }
     env->cc_dest = res;
     env->cc_src = op2;
-    cpu_m68k_flush_flags(env, env->cc_op);
+    env->cc_dest = cpu_m68k_flush_flags(env, op);
     /* !Z is sticky.  */
     env->cc_dest &= (old_flags | ~CCF_Z);
     return res;
@@ -789,9 +789,9 @@ void HELPER(mac_set_flags)(CPUM68KState *env, uint32_t acc)
     }
 }
 
-void HELPER(flush_flags)(CPUM68KState *env, uint32_t cc_op)
+uint32_t HELPER(flush_flags)(CPUM68KState *env, uint32_t op)
 {
-    cpu_m68k_flush_flags(env, cc_op);
+    return cpu_m68k_flush_flags(env, op);
 }
 
 uint32_t HELPER(get_macf)(CPUM68KState *env, uint64_t val)
diff --git a/target-m68k/helper.h b/target-m68k/helper.h
index c24ace5..0f5a7cf 100644
--- a/target-m68k/helper.h
+++ b/target-m68k/helper.h
@@ -45,5 +45,5 @@ DEF_HELPER_3(set_mac_extf, void, env, i32, i32)
 DEF_HELPER_3(set_mac_exts, void, env, i32, i32)
 DEF_HELPER_3(set_mac_extu, void, env, i32, i32)
 
-DEF_HELPER_2(flush_flags, void, env, i32)
+DEF_HELPER_2(flush_flags, i32, env, i32)
 DEF_HELPER_2(raise_exception, void, env, i32)
diff --git a/target-m68k/translate.c b/target-m68k/translate.c
index cddc2b5..16f09ca 100644
--- a/target-m68k/translate.c
+++ b/target-m68k/translate.c
@@ -422,7 +422,7 @@ static inline void gen_flush_flags(DisasContext *s)
     if (s->cc_op == CC_OP_FLAGS)
         return;
     gen_flush_cc_op(s);
-    gen_helper_flush_flags(cpu_env, QREG_CC_OP);
+    gen_helper_flush_flags(QREG_CC_DEST, cpu_env, QREG_CC_OP);
     s->cc_op = CC_OP_FLAGS;
 }
 
@@ -716,6 +716,7 @@ static void gen_jmpcc(DisasContext *s, int cond, TCGLabel *l1)
     /* TODO: Optimize compare/branch pairs rather than always flushing
        flag state to CC_OP_FLAGS.  */
     gen_flush_flags(s);
+    gen_flush_cc_op(s);
     switch (cond) {
     case 0: /* T */
         tcg_gen_br(l1);
@@ -1669,7 +1670,6 @@ DISAS_INSN(branch)
         /* bsr */
         gen_push(s, tcg_const_i32(s->pc));
     }
-    gen_flush_cc_op(s);
     if (op > 1) {
         /* Bcc */
         l1 = gen_new_label();